# Kenran Chat Lib
###
### [eBeB
###

###
# t
sub getDate {
    $ENV{'TZ'} = $CONF{'timezone'};
    local($times) = time;
    local($sec,$min,$hour,$mday,$mon) = localtime($times);
    return sprintf("%s/%s-%02d:%02d:%02d",$mon+1,$mday,$hour,$min,$sec);
}

###
# gbv擾
sub getTrip {
    local($name) = $_[0];
    local($tripped) = $name;
    # gbv@\LȂ΁AgbvȊOȂ΂̂܂܂Ԃ
    if ($CONF{'usetrip'} && $name =~ /(.*)(#|)(.*)/){
        $trip = &genTrip($1, $3);
        $tripped = "<b>" . $1 . "</b>" . $trip;
    } else {
        $tripped =~ s///g;
    }
    return $tripped;
}

###
# gbv
sub genTrip {
    local($name, $key) = @_;
    local($salt) = substr($key."H.", 1, 2);
    $salt =~ s/[^\.-z]/\./go;
    $salt =~ tr/:;<=>?@[\\]^_`/ABCDEFGabcdef/; #`
    return substr(crypt($key, $salt), -10);
}

###
# ANZXۏ
sub checkDeny {
    local($client) = $_[0];
    local($find)=0;
    open(DENY, "$CONF{'denyfile'}")
	|| &error("Open Error : $CONF{'denyfile'}");
    while (<DENY>) {
	s/\n//g;
	next if (!$_);
	s/\*/\.\*/g;
	if ($client =~ /$_/i) { $find=1; last; }
    }
    close(DENY);
    if ($find) { &error($CONF{'denymsg'}); }
}

###
#  bN
sub lock {
    local($lockfile) = $_[0]; # bNt@C͈Ŏw
    local($lockmode) = $CONF{'lockmode'};
    local($retry) = $CONF{'retry'};
    local($timeout) = $CONF{'timeout'};
    local($errmsg) = "Lock ($lockfile) is busy";

    # 莞ԈȏÂbN͍폜
    if (-e $lockfile) {
	($mtime) = (stat($lockfile))[9];
	if ($mtime < time - $timeout) { &unlock($lockfile); }
    }
    # symlink֐bN
    if ($lockmode == 1) {
	while (!symlink(".", $lockfile)) {
	    if (--$retry <= 0) { &error($errmsg); }
	    sleep(1);
	}
    # mkdir֐bN
    } elsif ($lockmode == 2) {
	while (!mkdir($lockfile, 0755)) {
	    if (--$retry <= 0) { &error($errmsg); }
	    sleep(1);
	}
    }
}

###
#  bN
sub unlock {
    local($lockfile) = $_[0]; # bNt@C͈Ŏw
    local($lockmode) = $CONF{'lockmode'};

    # symlink`
    if ($lockmode == 1) {
	unlink($lockfile);
    }
    # mkdir
    elsif ($lockmode == 2) {
	rmdir($lockfile);
    }
}

###
# 
sub clear {
    local($client, @lines) = @_;
    local(@temp) = ();
    local($match)=0;
    foreach (@lines) {
	local($cip) = (split(/<>/))[5];
	if ($client eq $cip) {
	    $match=1;
	} else {
	    push(@temp, $_);
	}
    }
    if ($match) {
	$IN{'comment'}="All Clear (^-^)v";
	return @temp;
    }
}

###
#  Oݏ
sub writeLog {
    # [hI
    local($mode) = $_[0];

    # O̓͂Ȃ΃G[
    if ($IN{'name'} eq "") {
	&error("L肢܂B");
    }
    # gbv
    local($tripped) = &getTrip($IN{'name'});

    $bye = 0; # O[oϐ
    local($name, $email, $color)= ("", "", "");
    # [h
    if ($mode eq 'login') {
	# bZ[Wݒ
	$IN{'comment'} = "$tripped $CONF{'in_msg'}";
	if ($CONF{'showip'}) {
	    $IN{'comment'} .= " &lt;$client&gt;";
	}
	$email = "";
	$name  = $CONF{'navi'};
	$color = $CONF{'navicolor'};
    }
    # ގ[h
    elsif ($mode eq 'logout') {
	$IN{'comment'} = "$tripped $CONF{'out_msg'}";
	$email = "";
	$name  = $CONF{'navi'};
	$color = $CONF{'navicolor'};
	$bye=1;
    }
    # ʏ탂[h
    else {
	if ($IN{'email'} eq "") {
	    $name = "<B>$CONF{'pointer'}</B>";
	}
	else {
	    $name = "<B><a href=\"mailto:$IN{'email'}\">";
	    $name .= "$CONF{'pointer'}</a></B>";
	}
	$name .= " $tripped ";
	$email = $IN{'email'};
	$color = $IN{'color'};
	
	# LO (IvV)
	if ($CONF{'ranking'}) {
	    &ranking();
	}
    }

    # Ot@C̃bNJn
    if ($CONF{'lockmode'}) { &lock($CONF{'lockfile'}); }

    # Ot@CJăf[^ǂݍ (zőlɒ)
    local($logfile) = $CONF{'logfile'};
    open(LOG, "$logfile") || &error("Open Error : $logfile");
    local(@lines) = <LOG>;
    close(LOG);

    #  (IvV)
    # R}h͂邱ƂŎ̋L폜
    if ($CONF{'clearlog'} && $IN{'comment'} eq $CONF{'clearcom'}) {
	@lines = &clear($client, @lines);
    }
    
    # őL܂ō
    while ($CONF{'max'} <= @lines) {
	pop(@lines);
    }

    $IN{'comment'} =~ s/\(\*\O\O\*\)/\(<font color=#EF8F9C>\*<\/font>\O\O<font color=EF8F9C>\*<\/font>\)/;

    # Ԃ擾
    local($date) = &getDate();

    # OtH[}bgčXV
    local($newline) = "$date<>$name<>$email<>";
    $newline .= "$IN{'comment'}<>$color<>$client<>\n";
    unshift (@lines, $newline);
    open(LOG, ">$logfile") || &error("Write Error : $logfile");
    print LOG @lines;
    close(LOG);

    # bN
    if ($CONF{'lockmode'}) { &unlock($CONF{'lockfile'}); }
}

###
#  LO
sub ranking {
    open(RANK,"<$CONF{'rankfile'}")
	|| &error("Open Error : $CONF{'rankfile'}");
    @rank = <RANK>;
    close(RANK);

    local($find)=0;
    local(@new) = ();
    # gbv̏
    local($tripped) = &getTrip($IN{'name'});
    foreach (@rank) {
	local($rname,$rcount,$rtime) = split(/<>/);
	local($nowtime) = time;
	if ($nowtime - $rtime > $CONF{'rankexp'}*24*60*60) {
	    $_=''; next;
	}
	if ($rname eq $tripped) {
	    $find=1; $rcount++;
	    $_ = "$rname<>$rcount<>$nowtime<>\n";
	}
	push(@new, $_);
    }
    # o^̏ꍇ
    if ($find == 0) {
	unshift(@new, "$tripped<>1<>$nowtime<>\n");
    }
    
    open(RANK,">$CONF{'rankfile'}")
	|| &error("Write Error : $CONF{'rankfile'}");
    print RANK @new;
    close(RANK);
}

###
### HTML֌W
###

###
# wb_[o͏ ()
sub printHeader {
    local($extra) = $_[0];

    print "Content-type: $CONF{'content-type'}\n";
    # GZIPkΉR[h (2006/02/10)
    if (${'HTTP_ACCEPT_ENCODING'} =~ /gzip/ && $gzip ne '') {
	if (${'HTTP_ACCEPT_ENCODING'} =~ /x-gzip/) {
	    print "Content-encoding: x-gzip\n";
	} else {
	    print "Content-encoding: gzip\n";
	}
	open (STDOUT, "|$gzip -1 -c"); # k͍ő(-1)
    }
    # GZIPkΉA܂
    print "\n"; # wb_I
    print <<"EOM";
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html lang="$CONF{'lang'}">
<head>
<meta http-equiv="Content-type" content="$CONF{'content-type'}" />
<meta http-equiv="Content-Language" content="$CONF{'lang'}" />
<meta name='robots' content='noindex, nofollow' />
<script type='text/javascript' src='$CONF{'javascript'}'></script>
<link rel="stylesheet" type="text/css" href="$CONF{'stylefile'}">
<title>$CONF{'title'}</title>
$extra
</head>
EOM
}

###
#  G[\ ()
sub error {
    local($errmsg) = $_[0];

    # bNt@C̉
    if ($CONF{'lockmode'}) {
	&unlock($CONF{'lockfile'});
	&unlock($CONF{'memlock'});
    }

    &printHeader();
    print << "EOM";
<body>
<center><h3>ERROR !</h3>
<font color='red'>$errmsg</font></center>
</body></html>
EOM
    exit(0);
}

###
# t[o͏
sub printFrame {
    # NbL[Ƀ[hԁ^ŝȂꍇ͏l
    if ($CK{'retime'} eq "") { $CK{'retime'} = $CONF{'retime'}; }
    if ($CK{'line'} eq "") { $CK{'line'} = $CONF{'line'}; }
    
    $formsrc = "$CONF{'script'}?mode=form&retime=$CK{'retime'}&line=$CK{'line'}";
    $logsrc = "$CONF{'script'}?mode=view&retime=$CK{'retime'}&line=$CK{'line'}";

    &printHeader();
    print <<"EOM";
<frameset rows="177,*" border=0>
<frame name="form" src="$formsrc">
<frame name="log" src="$logsrc">
<noframes>
<body>t[Ή̃uEU͗̕pł܂</body>
</noframes>
</frameset>
</html>
EOM
    exit(0);
}

###
# v_Ej[
sub genPullDown {
    local($script) = "$CONF{'script'}?mode=view&retime=0";
    local($pulldown) =<<"EOM";
<b><a href="javaScript:pullDown()">R`ɃOǂ߂܂</a></b> <div id="menu" style="position:absolute; visibility:hidden; background-color:#ffbdde; width:60px;">
<a href="$script&line=500" target="_blank">@TOO</a><BR>
<a href="$script&line=1000" target="_blank">@POOO</a><BR>
<a href="$script&line=1500" target="_blank">@PTOO</a><BR>
<a href="$script&line=2000" target="_blank">@QOOO</a><BR>
</div>
EOM
    return $pulldown;
}

###
# XVԑI𕔂̕񐶐
sub genReloadTimeSelection {
    # ͂ɂݒ肪΂D
    if ($IN{'retime'} ne "") {
	$CK{'retime'} = $IN{'retime'};
    }
    # ȂΏlɐݒ
    if ($CK{'retime'} eq "") {
	$CK{'retime'} = $CONF{'retime'};
    }

    local($reload) = "XV <select name=retime>\n";
    foreach (@reload) {
	if ($CK{'retime'} == $_) {
	    $reload .= "<option value=\"$_\" selected>$_b\n";
	} else {
	    $reload .= "<option value=\"$_\">$_b\n";
	}
    }
    $reload .= "</select>\n";
    return $reload;
}

###
# ͕̕񐶐
sub genLoginInput {
    local($login) =<<"EOM";
<b>NAME</b> <input type="text" name="name" size="25" value="$CK{'name'}"><br>
<b>EMail</b> <input type="text" name="email" size="25" value="$CK{'email'}"><br>
EOM
    return $login;
}

###
# `bg͕̕񐶐
sub genChatInput {
    # gbv̏
    local($tripped) = &getTrip($IN{'name'});
    local($chat) = << "EOM";
<input type="hidden" name="mode" value="chat">
<input type="hidden" name="name" value="$IN{'name'}">
<input type="hidden" name="email" value="$IN{'email'}">
<b>NAME</b>F@<font color="$IN{'color'}">$tripped</font>
<input type="submit" value="^[h">
<input type="reset" value="NA"><br>
<b></b>@F@<input type="text" size="85" name="comment"><br>
EOM
    return $chat;
}

###
# sI𕔂̕񐶐
sub genLineNumSelection {
    # ͂ɂݒ肪΂D
    if ($IN{'line'} ne "") {
	$CK{'line'} = $IN{'line'};
    }
    # ȂΏlɐݒ
    if ($CK{'line'} eq "") {
	$CK{'line'} = $CONF{'line'};
    }

    local($lines) = "s <select name=line>\n";
    foreach (@line) {
	if ($CK{'line'} == $_) {
	    $lines .= "<option value=\"$_\" selected>$_s\n";
	} else {
	    $lines .= "<option value=\"$_\">$_s\n";
	}
    }
    $lines .= "</select><br>\n";
    return $lines;
}

###
# FI(WI{^)̏o͏
sub genColorRadioBottun {
    # ͂ɂݒ肪΂D
    if ($IN{'color'} ne "") {
	$CK{'color'} = $IN{'color'};
    }
    # ȂΏlɐݒ
    if ($CK{'color'} eq "") {
	$CK{'color'} = $CONF{'color'};
    }

    local($colors) = "<B>FI</B><BR><BR>\n";

    local($half) = int (@COLORS / 2); # Ɋ
    local($i=0);
    foreach (@COLORS) {
	$i++;
	if ($CK{'color'} eq $_) {
	    $colors .= "<input type=radio name=color value=\"$_\" checked>";
	} else {
	    $colors .= "<input type=radio name=color value=\"$_\">";
	}
	$colors .= "<font color=\"$_\"><B>**</B></font>\n";
	if ($i == $half) { $colors .= "<br>\n"; }
    }
    return $colors;
}

###
# FI(ZNgj[)̏o͏
sub genColorSelection {
    # ͂ɂݒ肪΂D
    if ($IN{'color'} ne "") {
	$CK{'color'} = $IN{'color'};
    }
    # ȂΏlɐݒ
    if ($CK{'color'} eq "") {
	$CK{'color'} = $CONF{'color'};
    }

    local($colors) = "F <select name=color>\n";
    for ($i = 0; $i < scalar(@COLORS); $i++) {
	if ($IN{'color'} eq $COLORS[$i]) {
	    $colors .= "<option value=\"$COLORS[$i]\" selected>$IROIRO[$i]\n";
	} else {
	    $colors .= "<option value=\"$COLORS[$i]\">$IROIRO[$i]\n";
	}
    }
    $colors .= "</select>\n";
}

###
# 當I𕔂̕񐶐
sub genFaceSelection {
    local ($face) = " <select name=\"face\">";
    $face .= "<option value=\"\">Ȃ\n";
    foreach (@faces) {
	$face .= "<option value=\"$_\">$_\n";
    }
    $face .= "</select>\n";
    return $face;
}

###
#  ptH[o
sub printEntryForm {
    # v_Ej[̐
    local($pulldown) = '';
    if ($CONF{'pulldown'}) {
	$pulldown = &genPullDown();
    }

    local($login) = &genLoginInput();
    local($reload) = &genReloadTimeSelection();
    local($lines) = &genLineNumSelection();
    local($colors) = &genColorRadioBottun();

    # wb_[o
    &printHeader();
    print <<"EOM";
<body>
<form method="$CONF{'method'}" action="$CONF{'script'}"
 target="form" name="entry">
<input type=hidden name=mode value="login">
[<a href="$CONF{'homeurl'}" target="_top">BACK</a>]
 $CONF{'topdesc'} $pulldown <br><br>
<center>
<font color="#DB5673" SIZE=2><B></B></font>
@<b style="font-size:$t_size">$CONF{'title'}</b>
@<font color="#DB5673" SIZE=2><B></B></font>
</center>
<hr size=1 COLOR=#EF8F9C>
<table border="0" cellspacing="0" cellpadding="0" height="100">
<tr align="right">
<td>$login $reload $lines</td>
<td width="100" align="center"><br>
<input type="submit" value=""></td>
<td align=center valign=top nowrap><br>
$colors
</td></tr></table></form>
<SCRIPT LANGUAGE="JavaScript">
<!--
self.document.entry.name.focus();
//-->
</SCRIPT>
</body></html>
EOM
    exit(0);
}

###
# LO̕񐶐
sub genRanking {
    local($ranking) =<<"EOM";
[<a href="$CONF{'adminscript'}?mode=ranking&retime=$IN{'retime'}&line=$IN{'line'}"
 target="log">LO</a>]
EOM
    return $ranking;
}

###
# tH[o
sub printChatForm {
    # v_Ej[̐
    local($pulldown) = '';
    if ($CONF{'pulldown'}) {
	$pulldown = &genPullDown();
    }

    local($chat) = &genChatInput();
    local($face) = &genFaceSelection();
    local($colors) = &genColorSelection();
    local($lines) = &genLineNumSelection();
    local($reload) = &genReloadTimeSelection();

    # LO̐
    if ($CONF{'ranking'}) {
	local($ranking) = &genRanking();
    }

    # Oݏ
    &writeLog('login');

    # NbL[̐ݒ
    local($ck) = "name<>$IN{'name'}";
    $ck .= "<>email<>$IN{'email'}";
    $ck .= "<>color<>$IN{'color'}";
    $ck .= "<>retime<>$IN{'retime'}";
    $ck .= "<>line<>$IN{'line'}";
    &setCookie($CONF{'cookiekey'}, $ck, $CONF{'expire'});

    # wb_o
    &printHeader();
    print <<"EOM";
<body>
<form name="send" method="$CONF{'method'}" action="$CONF{'script'}"
 target="log" onSubmit="setTimeout(&quot;autoclear()&quot;,10)">
<table border=0><tr><td colspan=3>
<b><font color="#DB5673" size="2"></font>
$CONF{'title'}
<font color="#DB5673" size="2"></font></b>@
<br> $CONF{'chatalart'} $pulldown
<br><br>$chat
</td></tr>
<tr><td>$face $colors $reload $lines</td></form>
<td valign="top">
<form action="$CONF{'script'}" method="$CONF{'method'}" target="form">
<input type="submit" value="ގ錾">
<input type="hidden" name="mode" value="logout">
<input type="hidden" name="name" value="$IN{'name'}">
</td></form>
<td>
<form name="cmode">
<input type="checkbox" name="autoclear" checked>
</td></form></tr></table><br>
[<a href="$CONF{'adminscript'}?mode=enter&retime=$IN{'retime'}&line=$IN{'line'}" target="log">Ǘp</a>]
$ranking
</body></html>
EOM
    exit(0);
}

###
#  ݎҏ
sub genMember {
    local($mode) = $_[0];

    # bN
    if ($CONF{'lockmode'}) { &lock($CONF{'memlock'}); }

    # o[ꗗ擾
    open(MEM, "<$CONF{'memfile'}")
	|| &error("Open Error : $CONF{'memfile'}");
    local(@line) = <MEM>;
    close(MEM);

    # ϐ
    local(@new) = ();
    local($member, $update, $even) = ("", 0, 0);
    local($time0, $name0, $client0) = (0, '', '');
    # gbv̏
    local($tripped) = &getTrip($IN{'name'});
    # ݎ擾
    local($nowtime) = time;
    foreach (@line) {
	($time0, $name0, $client0) = split(/<>/);

	# 莞Ԉȏ㔭̂Ȃ҂͍폜
	if ($nowtime - $CONF{'memexp'} > $time0) { next; }

	# NCAgIPꂩOꏏł΍XV
	elsif ($client0 eq $client && $name0 eq $tripped) {
	    # ގ҂͍폜
	    if ($mode eq 'logout') { next; }

	    # ԂƖOXVĒǉ
	    push (@new, "$nowtime<>$tripped<>$client<>\n");
	    $name0 = $tripped;
	    $update=1;
	}
	# ȊO͖ⓚpōXVpz @new ɒǉ
	else { push(@new, $_); }
	
	# Qҕ\p쐬 (Ń}[NύX)
	if (!$even) {
	    $member .= "$name0"; $even=1;
	}
	else {
	    $member .= "$name0"; $even=0;
	}
    }
    
    # XVȊOŃOAEgĂȂȂΐVKQ҂ǉ
    if (!$update && !$bye) {
	if ($IN{'name'} ne $client) {
	    push(@new, "$nowtime<>$tripped<>$client<>\n");
	    if (!$even) {
		$member .= "$tripped";
	    }
	    else {
		$member .= "$tripped";
	    }
	}
    }

    # t@CXV
    if ($IN{'mode'} || $IN{'retime'}) {
	open(MEM,">$CONF{'memfile'}")
	    || &error("Write Error : $CONF{'memfile'}");
	print MEM @new;
	close(MEM);
    }

    # bN
    if ($CONF{'lockmode'}) { &unlock($CONF{'memlock'}); }

    # QҐF
    local($num) = 0;
    $num = @new;
    return "Q($num)F".$member;
}

###
#  ގ
sub printLogout {
    &writeLog('logout');
    local($member) = &genMember('logout');
    local($tripped) = &getTrip($IN{'name'});
    &printHeader();
    print <<"EOM";
<body>
<center><BR><BR><h3>lłA$tripped B܂܂傤B</h3>
<form action="$CONF{'homeurl'}" target="_top">
<input type=submit value="E"></form></center>
</body></html>
EOM
    exit(0);
}

###
#  O\
sub viewLog {
    # [hwb_
    local($extra) = '';
    if ($IN{'retime'} != 0) {
	local($ename) = &url_enc($IN{'name'});
	local($script) = "$CONF{'script'}?mode=view&retime=$IN{'retime'}&line=$IN{'line'}&name=$ename";
	$extra = "<meta http-equiv=\"refresh\"";
	$extra .= " content=\"$IN{'retime'}; URL=$script\">\n";
    }
    &printHeader($extra);

    ## Qҕ\
    local($member) = &genMember();
    print "<body>\n";
    print "<hr size=1 color=#EF8F9C width='100%'>";
    print "<table width='100%'><tr><td>$member</td>\n";
    print "<td align=right>[hF ";
    if ($IN{'retime'} == 0) {
	print "蓮[h";
    } else { print "$IN{'retime'}b"; }
    print " s: $IN{'line'}s</td></tr></table>\n";
    
    # O\
    $i=0;
    open(LOG,"$CONF{'logfile'}")
	|| &error("Open Error : $CONF{'logfile'}");
    while (<LOG>) {
	$i++;
	if ($i > $IN{'line'}) { last; }
	local($date,$name,$email,$comment,$color) = split(/<>/);
	print "<hr size=1 color=EF8F9C><font color=\"$color\">$name  $comment</font> ";
	print "<font color=\"$rep_color\">($date)</font><br>\n";
    }
    close(LOG);
    
    # 쌠\i폜֎~j
    print &genCopyRight();
    print "</body></html>\n";
    exit(0);
}

###
# 쌠񐶐
sub genCopyRight {
    local ($copyRight) = "<hr><p>쌠\(ǂ̂)</p>\n";
    return $copyRight;
}

# End of kenranlib
1;
